<?php

namespace App\Exceptions;

use Auth;
use Exception;
use Illuminate\Session\TokenMismatchException;
use Illuminate\Foundation\Exceptions\Handler as ExceptionHandler;
use Throwable;

class Handler extends ExceptionHandler
{
    /**
     * A list of the exception types that are not reported.
     *
     * @var array
     */
    protected $dontReport = [
        //
    ];

    /**
     * A list of the inputs that are never flashed for validation exceptions.
     *
     * @var array
     */
    protected $dontFlash = [
        'password',
        'password_confirmation',
    ];

    /**
     * Report or log an exception.
     *
     * @param  \Throwable  $exception
     * @return void
     *
     * @throws \Exception
     */
    public function report(Throwable $exception)
    {
        parent::report($exception);
    }

    /**
     * Render an exception into an HTTP response.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Throwable  $exception
     * @return \Symfony\Component\HttpFoundation\Response
     *
     * @throws \Throwable
     */
    public function render($request, Throwable $exception)
    {
        if ($this->isHttpException($exception)) {
            if($request->segment(1) == 'admin'){
                if (view()->exists('admin.errors.' . $exception->getStatusCode())) {
                    return response()->view('admin.errors.' . $exception->getStatusCode(), [], $exception->getStatusCode());
                }
            }else{
                if (view()->exists('errors.' . $exception->getStatusCode())) {
                    return response()->view('errors.' . $exception->getStatusCode(), [], $exception->getStatusCode());
                }
            }
        }

        if ($exception instanceof TokenMismatchException) {
            if($request->segment(1) == 'admin'){
                Auth::guard('admin')->logout();
                return redirect(route('admin.login'))->with('error', 'Page session expired. Please try again');
            }
        }

        return parent::render($request, $exception);
    }
}
